from ctypes import *
lib = cdll.LoadLibrary(".\\CAF_Python_Plugins_64.dll")

def CAF_Settrade_GetAccountEquity(brokerId,accNo,port):
    result = lib.CAF_Settrade_GetAccountEquity
    result.restype = c_double
    result.argtypes = [c_char_p,c_char_p,c_int]
    return result(brokerId.encode(),accNo.encode(),port)

def CAF_Settrade_GetAccountInfo(brokerId,accountNo,port):
    result = lib.CAF_Settrade_GetAccountInfo
    result.restype = c_char_p
    result.argtypes = [c_char_p,c_char_p,c_int]
    return result(brokerId.encode(),accountNo.encode(),port)

def CAF_Settrade_GetPortfolios(brokerId,accountNo,port):
    result = lib.CAF_Settrade_GetPortfolios
    result.restype = c_char_p
    result.argtypes = [c_char_p,c_char_p,c_int]
    return result(brokerId.encode(),accountNo.encode(),port)


def CAF_Settrade_GetAllOrderList(brokerId,accountNo,port):
    result = lib.CAF_Settrade_GetAllOrderList
    result.restype = c_char_p
    result.argtypes = [c_char_p,c_char_p,c_int]
    return result(brokerId.encode(),accountNo.encode(),port)


def CAF_Settrade_GetAllTradeList(brokerId,accountNo,port):
    result = lib.CAF_Settrade_GetAllTradeList
    result.restype = c_char_p
    result.argtypes = [c_char_p,c_char_p,c_int]
    return result(brokerId.encode(),accountNo.encode(),port)

def CAF_Settrade_SetPortPosition(brokerId,accNo,pin,symbol,targetPos,port):
    result = lib.CAF_Settrade_SetPortPosition
    result.restype = c_int
    result.argtypes = [c_char_p,c_char_p,c_char_p,c_char_p,c_int,c_int]
    return result(brokerId.encode(),accNo.encode(),pin.encode(),symbol.encode(),targetPos,port)

def CAF_Settrade_CancelOrder(brokerId,accountNo,pin,symbol,orderNo,port):
    result = lib.CAF_Settrade_CancelOrder
    result.restype = c_char_p
    result.argtypes = [c_char_p,c_char_p,c_char_p,c_char_p,c_char_p,c_int]
    return result(brokerId.encode(),accountNo.encode(),pin.encode(),symbol.encode(),orderNo.encode(),port)

def CAF_Settrade_CancelAllOrder(brokerId,accountNo,pin,symbol,port):
    result = lib.CAF_Settrade_CancelAllOrder
    result.restype = c_char_p
    result.argtypes = [c_char_p,c_char_p,c_char_p,c_char_p,c_int]
    return result(brokerId.encode(),accountNo.encode(),pin.encode(),symbol.encode(),port)

def CAF_Settrade_SendOrder(brokerId,accountNo,pin,symbol,side,priceType,validity,price,vol,port):
    result = lib.CAF_Settrade_SendOrder
    result.restype = c_char_p
    result.argtypes = [c_char_p,c_char_p,c_char_p,c_char_p,c_char_p,c_char_p,c_char_p,c_double,c_int,c_int]
    return result(brokerId.encode(),accountNo.encode(),pin.encode(),symbol.encode(),side.encode(),priceType.encode(),validity.encode(),price,vol,port)

def CAF_Settrade_SendStopOrder(brokerId,accountNo, pin,symbol,side,priceType,validity,stopSymbol,stopCond,price,vol,stopPrice,port):
    result = lib.CAF_Settrade_SendStopOrder
    result.restype = c_char_p
    result.argtypes = [c_char_p,c_char_p,c_char_p,c_char_p,c_char_p,c_char_p,c_char_p,c_char_p,c_char_p,c_double,c_int,c_double,c_int]
    return result(brokerId.encode(),accountNo.encode(), pin.encode(),symbol.encode(),side.encode(),priceType.encode(),validity.encode(),stopSymbol.encode(),stopCond.encode(),price,vol,stopPrice,port)


